* BARCODE.PRG
* Prints a BarCode
* Midnight Logic by Mark Farrell
*   - Will BarCode numbers, upper case letters, space and: - . + % $ /
*   - Parameters: mCODE   - the string to be coded
*                 mHEIGHT - height of BarCode
*                         - "SINGLE", "DOUBLE", "TRIPLE" or "QUAD"
*                 mINDENT - how many spaces to indent BarCode from left margin
*                         - numeric
*   - NULL2PRN.BIN must be loaded to send Nulls to the printer
*   - SET CONSOLE OFF and SET PRINT ON before running this routine
*   - Follow this routine with: ?? CHR(27) + "2"  && to reset line spacing
*
*   The calling program should look something like this:
*
*       SET CONSOLE OFF
*       SET PRINT ON
*       DO BARCODE WITH "092234", "SINGLE", 5
*       ?? SPACE(20) + "Printed on same line as BarCode; space past BarCode"
*       ?? CHR(27) + "2"      && reset line spacing to 6 lpi
*       ?  SPACE(5) + "Prints directly below BarCode; print font untouched"
*
* DATE: Mon  07-31-1989
* ===========================================================================

PARAMETER mCODE, mHEIGHT, mINDENT

* ------------------------------------------------------ Intialize Variables
mCODE = "*" + UPPER(mCODE) + "*"
mLENGTH = LEN(mCODE)
mINDENT = INT(ABS(mINDENT))
DIMENSION aPRN_CODE(mLENGTH)
* ----------------- Convert mHEIGHT to number
mHEIGHT = UPPER(mHEIGHT)
DO CASE
    CASE mHEIGHT = "SINGLE"
        mHEIGHT = 3
    CASE mHEIGHT = "DOUBLE"
        mHEIGHT = 5
    CASE mHEIGHT = "TRIPLE"
        mHEIGHT = 7
    CASE mHEIGHT = "QUAD"
        mHEIGHT = 9
    OTHERWISE      && double height for bad parameter
        mHEIGHT = 5  
ENDCASE

LOAD NULL2PRN   && Mark's Patented Send-a-Null-to-Camp BIN routine!!
                **   You'll probably want to load this in the calling routine
                **   and just CALL it from here...


* ----------------- Build strings of 1s and 0s to later be printed as BarCode
*                   Load strings into aPRN_CODE
mX = 1
DO WHILE mX <= mLENGTH
    mCHARACTER = SUBSTR(mCODE,mX,1)

    DO CASE
        * ----------------- Start and Stop Character
        CASE mCHARACTER = "*"
            mCHAR_CODE = "1000010011100111001"

        * ----------------- You got your numbers
        CASE mCHARACTER = "0"
            mCHAR_CODE = "1001000011100111001"
        CASE mCHARACTER = "1"
            mCHAR_CODE = "1110010000100100111"
        CASE mCHARACTER = "2"
            mCHAR_CODE = "1001110000100100111"
        CASE mCHARACTER = "3"
            mCHAR_CODE = "1110011100001001001"
        CASE mCHARACTER = "4"
            mCHAR_CODE = "1001000011100100111"
        CASE mCHARACTER = "5"
            mCHAR_CODE = "1110010000111001001"
        CASE mCHARACTER = "6"
            mCHAR_CODE = "1001110000111001001"
        CASE mCHARACTER = "7"
            mCHAR_CODE = "1001000010011100111"
        CASE mCHARACTER = "8"
            mCHAR_CODE = "1110010000100111001"
        CASE mCHARACTER = "9"
            mCHAR_CODE = "1001110000100111001"

        * ----------------- You got you letters
        CASE mCHARACTER = "A"
            mCHAR_CODE = "1110010010000100111"
        CASE mCHARACTER = "B"
            mCHAR_CODE = "1001110010000100111"
        CASE mCHARACTER = "C"
            mCHAR_CODE = "1110011100100001001"
        CASE mCHARACTER = "D"
            mCHAR_CODE = "1001001110000100111"
        CASE mCHARACTER = "E"
            mCHAR_CODE = "1110010011100001001"
        CASE mCHARACTER = "F"
            mCHAR_CODE = "1001110011100001001"
        CASE mCHARACTER = "G"
            mCHAR_CODE = "1001001000011100111"
        CASE mCHARACTER = "H"
            mCHAR_CODE = "1110010010000111001"
        CASE mCHARACTER = "I"
            mCHAR_CODE = "1001110010000111001"
        CASE mCHARACTER = "J"
            mCHAR_CODE = "1001001110000111001"
        CASE mCHARACTER = "K"
            mCHAR_CODE = "1110010010010000111"
        CASE mCHARACTER = "L"
            mCHAR_CODE = "1001110010010000111"
        CASE mCHARACTER = "M"
            mCHAR_CODE = "1110011100100100001"
        CASE mCHARACTER = "N"
            mCHAR_CODE = "1001001110010000111"
        CASE mCHARACTER = "O"
            mCHAR_CODE = "1110010011100100001"
        CASE mCHARACTER = "P"
            mCHAR_CODE = "1001110011100100001"
        CASE mCHARACTER = "Q"
            mCHAR_CODE = "1001001001110000111"
        CASE mCHARACTER = "R"
            mCHAR_CODE = "1110010010011100001"
        CASE mCHARACTER = "S"
            mCHAR_CODE = "1001110010011100001"
        CASE mCHARACTER = "T"
            mCHAR_CODE = "1001001110011100001"
        CASE mCHARACTER = "U"
            mCHAR_CODE = "1110000100100100111"
        CASE mCHARACTER = "V"
            mCHAR_CODE = "1000011100100100111"
        CASE mCHARACTER = "W"
            mCHAR_CODE = "1110000111001001001"
        CASE mCHARACTER = "X"
            mCHAR_CODE = "1000010011100100111"
        CASE mCHARACTER = "Y"
            mCHAR_CODE = "1110000100111001001"
        CASE mCHARACTER = "Z"
            mCHAR_CODE = "1000011100111001001"

        * ----------------- You got your other stuff
        CASE mCHARACTER = " "
            mCHAR_CODE = "1000011100100111001"
        CASE mCHARACTER = "-"
            mCHAR_CODE = "1000010010011100111"
        CASE mCHARACTER = "."
            mCHAR_CODE = "1110000100100111001"
        CASE mCHARACTER = "+"
            mCHAR_CODE = "1000010010000100001"
        CASE mCHARACTER = "%"
            mCHAR_CODE = "1001000010000100001"
        CASE mCHARACTER = "$"
            mCHAR_CODE = "1000010000100001001"
        CASE mCHARACTER = "/"
            mCHAR_CODE = "1000010000100100001"
    ENDCASE

    aPRN_CODE(mX) = mCHAR_CODE
    mX = mX + 1
ENDDO   while mX <= mLENGTH


* ----------------- The message has been coded into array aPRN_CODE
*                   Now to actually print the barcode.
mPRN_PASS = 1
DO WHILE mPRN_PASS < mHEIGHT
    * ---- The following line determines the horizontal position of the BarCode
    ?? SPACE(mINDENT)

    * ----------------- The next 5 lines set up printer graphics (IBM Graphics)
    ?? CHR(27)
    ?? CHR(51)
    ?? CHR(2)

    ?? CHR(27) + CHR(76) + CHR(21*mLENGTH)
    CALL NULL2PRN

    * ----------------- This loop decodes 0's and 1's from array aPRN_CODE(mX)
    *                    into printed bars & spaces.
    mX = 1
    DO WHILE mX <= mLENGTH

        mSINGLCODE = LEN(aPRN_CODE(mX))
        mXX = 1
        DO WHILE mXX < (mSINGLCODE + 1)
            mONE_ZERO = SUBSTR(aPRN_CODE(mX),mXX,1)
            
            * ----------------- Actually fire them pins
            IF mONE_ZERO = "0"
                CALL NULL2PRN
              ELSE   && mONE_ZERO = "1"
                ?? CHR(255)
            ENDIF   mONE_ZERO = "0"
           
            mXX = mXX + 1
        ENDDO   while mXX < (mSINGLCODE + 1)

        CALL NULL2PRN
        CALL NULL2PRN

        mX = mX + 1
    ENDDO   while mX <= mLENGTH
 
    * ----------------- Paper feed to print next segment of barcode.
    IF    (mPRN_PASS = 2 .AND. mHEIGHT <> 3) ;
     .OR. (mPRN_PASS = 4 .AND. mHEIGHT <> 5) ;
     .OR. (mPRN_PASS = 6 .AND. mHEIGHT <> 7) ;
     .OR. (mPRN_PASS = 8 .AND. mHEIGHT <> 9)
        ?? CHR(27) + CHR(74) + CHR(21)
    ENDIF   all that stuff...

    ?   && 2/216th inch paper feed

    mPRN_PASS = mPRN_PASS + 1
ENDDO   while mPRN_PASS < mHEIGHT

RETURN

* ===========================================================================

